

#include <stdio.h>     

int N;
long X;

int Val[101], Num[101], Renum[101];

int M[101][101];
long A[101][101];
#define INF 1006666666L
int Ri, Rj, Rs, Re;

int try_start(int s)
{
    int i, j, k;
    int cont = 0;
    
    for (i = 1; i <= N; i++)
     for (j = 1; j <= N; j++)
      A[i][j] = (i >= s && j >= s && M[i][j]) ? M[i][j] : INF;
    for (k = s; k <= N; k++)
    {
        for (i = s; i <= N; i++)
	 if (A[i][k] <= INF)
            for (j = s; j <= N; j++)
             if (A[i][j] > A[i][k] + A[k][j])
                 A[i][j] = A[i][k] + A[k][j];
        for (i = s; i <= k; i++)
         for (j = s; j <= k; j++)
         {
	     if (A[i][j] < X)
                 cont = 1;
	     if (A[i][j] == X)
             {
                 Ri = i, Rj = j, Rs = Val[s], Re = Val[k];
                 return 0;
             }
         }
    }
    return cont ? 1 : -1;
}

void solve()
{
    int i;
    for (i = 1; i < N; i++)
     if (try_start(i) != 1) break;
}

void read_data()
{
    int i, j, t, m;
    FILE *fi = fopen("virus.in", "rt");
    fscanf(fi, "%d %d %ld", &N, &m, &X);
    for (i = 1; i <= N; i++)
    {
        fscanf(fi, "%d", Val + i);
        Renum[i] = Num[i] = i;
    }
    for (i = 1; i < N; i++)
     for (j = i+1; j <= N; j++)
     if (Val[i] > Val[j])
     {
         Renum[Num[i]] = j, Renum[Num[j]] = i;
         t = Val[i], Val[i] = Val[j], Val[j] = t;
         t = Num[i], Num[i] = Num[j], Num[j] = t;
     }
    while (m--)
    {
        fscanf(fi, "%d %d %d", &i, &j, &t);
        M[Renum[i]][Renum[j]] = M[Renum[j]][Renum[i]] = t;
    }
    fclose(fi);
}

int main()
{
    read_data();
    solve();
    fprintf(fopen("virus.out", "wt"), "%d %d %d %d\n", Num[Ri], Num[Rj], Rs, Re);
    return 0;
}
